﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace esl
{
    class EmailMessageRest
    {
        public static void main()
        {
            string jsonString = "{\"documents\":[{\"approvals\":[{\"id\":\"ExampleSignatureId\",\"role\":\"Signer1\",\"fields\":[{\"page\":0,\"top\":100,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\",\"name\":\"ExampleSignatureId\"}],\"name\":\"\"}],\"id\":\"sample-contract\",\"name\":\"Test Document\"}],\"status\":\"SENT\",\"type\":\"PACKAGE\",\"roles\":[{\"emailMessage\":{\"content\":\"Please sign the documents ASAP.\"},\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail45@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}],\"name\":\"Signer1\"}],\"name\":\"Example Package\"}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", Properties.Settings.Default.key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri("https://sandbox.esignlive.com/api/packages/"), form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
